function [G,Gamma,Gammap,Gammadp,Gammas,Gammaps,Gp,Gdp,Gs,Gps,lambda] = const(omegabar,sigma,mu,full)
          
z       =   (log(omegabar)+sigma^2/2)/sigma;%here, -sigma^2/2 is the mean of the underlying normal.
G       =   normcdf(z-sigma);%see page 53, BGG
            
if full==1
Gamma   =   normcdf(z-sigma)+omegabar*(1-normcdf(z));%see page 53, BGG
zs      =   -(log(omegabar)/(sigma^2))+0.5;%derivative of z with respect to sigma
Gammas  =   (zs-1)*normpdf(z-sigma)-omegabar*normpdf(z)*zs;%this is the derivative of Gamma with respect to sigma
Gammap  =   1-logncdf(omegabar,-sigma^2/2,sigma);%derivative of gamma with respect to omegabar (see 'technical background manuscript')
eep     =   .00001;
Gammaps =   -(logncdf(omegabar,-(sigma+eep)^2/2,sigma+eep)-logncdf(omegabar,-sigma^2/2,sigma))/eep;
Gammadp =   -lognpdf(omegabar,-sigma^2/2,sigma);%see technical background manuscript

Gs      =   (zs-1)*normpdf(z-sigma);
Gp      =   omegabar*lognpdf(omegabar,-sigma^2/2,sigma); %see technical background manuscript 
Gps     =   omegabar*(lognpdf(omegabar,-(sigma+eep)^2/2,sigma+eep)-lognpdf(omegabar,-sigma^2/2,sigma))/eep;
dd      =   (lognpdf(omegabar+eep,-sigma^2/2,sigma)-lognpdf(omegabar,-sigma^2/2,sigma))/eep;
Gdp     =   lognpdf(omegabar,-sigma^2/2,sigma)+omegabar*dd;
lambda  =   Gammap/(Gammap-mu*Gp);
else
    Gamma=0; Gammap=0; Gammadp=0; Gammas=0; Gammaps=0; Gp=0; Gdp=0; Gs=0; Gps=0; lambda=0;
end

varargout(1)={Gamma};
varargout(2)={Gammap};
varargout(3)={Gammadp};
varargout(4)={Gammas};
varargout(5)={Gammaps};
varargout(6)={Gp};
varargout(7)={Gdp};
varargout(8)={Gs};
varargout(9)={Gps};
varargout{10}={lambda};