function []=doplot(tt,pi,Pe,beta,muzstar,y2,y1,inf2,inf1,inv2,inv1,q2,q1,c2,c1,w2,w1,l2,l1,real_R2,real_R1, ...
            Rehatp2,Rehatp1,String1,Re,t,legendstr1,legendstr2)       

                  
%this plotting program graphs impulse responses for the RBC model, as well
%as whatever version of the CMR model is being analyzed (i.e., entr = 1, 0
%or -1). It needs to know whether entr = 1 or not, because this determines
%if financial variables are to be plotted.
                  
figure
orient landscape

x  = 3; %no. of rows in the plot
xx = 3; %no. of columns

subplot(x,xx,1)
%vline=(max(y2*100)-min(y2*100))/100; if sign(min(y2))==1; indx=0.5;else; indx=1.5;end;
if isempty(y1) == 0
    plot(tt,y1(tt)*100,'b-',tt,y2(tt)*100,'ko-',t,y1(t)*100,'*');
    legend(legendstr1,legendstr2)
else
    plot(tt,y2(tt)*100,'ko-')
end
xlabel('t');
ylabel('percent');
axis tight
title('Output');

subplot(x,xx,2)
if isempty(inv1) == 0
    plot(tt,inv1(tt)*100,'b-',tt,inv2(tt)*100,'ko-',t,inv1(t)*100,'*')
else
    plot(tt,inv2(tt)*100,'ko-')
end
xlabel('t');
ylabel('percent');
axis tight
title('Investment');


subplot(x,xx,3)
if isempty(c1) == 0
    plot(tt,c1(tt)*100,'b-',tt,c2(tt)*100,'ko-',t,c1(t)*100,'*');
else
    plot(tt,c2(tt)*100,'ko-')  
end
axis tight
xlabel('t');
ylabel('percent');
title('Consumption');


subplot(x,xx,4)
if isempty(l1) == 0
    plot(tt,l1(tt)*100,'b-',tt,l2(tt)*100,'ko-',t,l1(t)*100,'*');
else
    plot(tt,l2(tt)*100,'ko-')
end
axis tight
xlabel('t');
ylabel('percent');
title('Hours Worked');


subplot(x,xx,5)
if isempty(w1) == 0
    plot(tt,w1(tt)*100,'b-',tt,w2(tt)*100,'ko-',t,w1(t)*100,'*');
else
    plot(tt,w2(tt)*100,'ko-')
end
axis tight
xlabel('t');
ylabel('percent');
title('Real Wage');


subplot(x,xx,6)
if isempty(real_R1) == 0    
    plot(tt,real_R1(tt)*400*100,'b-',tt,real_R2(tt)*400*100,'ko-',t,real_R1(t)*400*100,'*')
    title('Ex post realized real R_{t+1}^{e}/\pi _{t+1} (annual)')
else
    plot(tt,real_R2(tt)*400*100,'ko-')
    title('Riskfree rate with payoff in t+1 (annual)')  
end   
axis tight
xlabel('t')
ylabel('basis points')

subplot(x,xx,7)
if isempty(q1) == 0
    plot(tt,q1(tt)*100,'b-',tt,q2(tt)*100,'ko-',t,q1(t)*100,'*');
else
    plot(tt,q2(tt)*100,'ko-');
end    
axis tight
%set (gca,'XTick',[0 20])
ylabel('percent');
xlabel('t');
title('P_{k''}');

if isempty(inf1) == 0
    subplot(x,xx,8)
    if isempty(inf2)==0
        plot(tt,inf1(tt)*pi*400,'b-',tt,inf2(tt)*pi*400,'ko-',t,inf1(t)*pi*400,'*'); 
    else
        plot(tt,inf1(tt)*pi*400,'b-',t,inf1(t)*pi*400,'*');
    end
    axis tight
    %set (gca,'XTick',[0 20])
    xlabel('t');
    title('Inflation (APR)');
end

if isempty(Rehatp1) == 0
    subplot(x,xx,9)
    if isempty(Rehatp2)==0
        plot(tt,Rehatp1(tt)*Re*400*100,'b-',tt,Rehatp2(tt)*Re*400*100,'ko-',t,Rehatp1(t)*Re*400*100,'*');
    else
        plot(tt,Rehatp1(tt)*Re*400*100,'b-',t,Rehatp1(t)*Re*400*100,'*');
    end
    axis tight
    %set (gca,'XTick',[0 20])
    ylabel('basis points');
    xlabel('t');
    title('Nominal Interest Rate (R_{t+1}^{e}, annual)');

    text(-60,-85,'Note: subscript on nominal rate of interest indicates date of payoff. R_{t+1}^{e} is graphed at date t. \pi _{t} indicates gross change in price level from t-1 to t.')
end
   
hout=suptitle(String1);

