function [Yhat,Yhat_,VYhat] = forecastkalman(Y,H,F,Q,R,B1,P,t1,LL,alf,initxi,tauvar,plot_levels,meanxxx,mm, ...
    trendm3,trendm1,fdiff,alpha,b,beta,is,taum,taub,taus,tausb,l_z,l_psi,D,taushock,outfolder,parstoch,date,f_name,xsmooth,Vsmooth,err,random_innovations,conditional)

%conditional = 3; %=0 unconditional forecast
                 %=1 conditioning on one or more variables and the user provides string of innovations
                 %=2 conditioning on one or more variables and the user provides the value that constrained variables should assume and the location of shocks whose innovations are allowed to be non-zero
                 %=3 conditioning on one or more variables, using ECB Projections as baseline scenario, and the user provides the value that constrained variables should assume and the location of shocks whose innovations are allowed to be non-zero
                 %=4 same as =3 with an alternative procedure

T = size(Y,2);

l_xxx = size(taum,1);
if length(tauvar) < l_xxx
    if is == 1
        HH    =   [taum,taub,taus,tausb];
    else
        HH    =   [taum,taub,taus];
    end
else
    HH = H;
end

appendnomM  = 1; %=1 appends nominal M1 growth, nominal M3 growth, nominal oil price growth, nominal net-worth growth, nominal credit
if appendnomM == 1
    nstates = size(HH,2);
    addon = zeros(4,nstates);
    addon(1,:) = HH(2,:) + HH(8,:); % nominal M1 growth
    addon(2,:) = HH(2,:) + HH(9,:); % nominal M3 growth
    addon(3,:) = HH(2,:) + HH(1,:); % nominal net-worth growth
    addon(4,:) = HH(2,:) + HH(18,:); % nominal oil growth
    addon(5,:) = HH(2,:) + HH(4,:);  %nominal credit growth
    HH = [HH; addon];
    alf = [alf;0;0;0;0;0];
end

if conditional == 0 || conditional ==1 || conditional == 2
    T_end = t1; %T;
elseif conditional == 3 || conditional || 4
    T_end = T;
end

% [xsmooth, Vsmooth, VVsmooth, loglik]  = kalman_smoother(Y(:,1:T_end), F, H, Q, R, initxi, P,alf(tauvar'));
%[xsmooth, Vsmooth, VVsmooth, loglik] = kalman_smoother(Y(:,1:T_end), F, H, Q, R,initxi, P);

% s = [2*l_z+1:2*l_z+l_psi];
% for ii = 2:T_end
%     err(:,ii) = xsmooth(s,ii)-F(s,s)*xsmooth(s,ii-1);
% end
% err(:,1) = xsmooth(s,1);
% 
% ix=1;
% for ii = 1:length(taushock)
%     d(ix)=1;
%     if parstoch(taushock(ii)) == 0
%         ix=ix+2;
%     else
%         d(ix+2)=1;
%         ix=ix+2+parstoch(taushock(ii));
%     end
% end
% I=find(d==1);
% 
% err = err(I,:);

if conditional == 0 || conditional ==1 || conditional == 2
    innovation = zeros(size(D,2),LL); %innovations are set to zero

    whitening =0; %=1 use innovations that have been found fitting AR(1) process on each time-series innovation (estimated in sample); =0 do nothing, i.e. innovations are set to zero
    if whitening ==1
        figure; orient landscape
        n1=4;
        n2=4;
        tt_= t1-7 ; %fit AR(1) over last 8 qurters

        for ii=1:length(I)
            y_innov = err(ii,tt_:end)'; x_innov = err(ii,tt_-1:end-1)';
            bet_ = (x_innov'*x_innov)\(x_innov'*y_innov);

            innov_forcast(1) = y_innov(end)*bet_;
            for jk=2:LL
                innov_forcast(jk) = innov_forcast(jk-1)*bet_;
            end

            subplot(n1,n2,ii)
            plot(1:length(y_innov)+LL,[y_innov; innov_forcast'],'r-',1:length(y_innov)+LL,[y_innov; zeros(LL,1)],'k-')
            axis tight
            grid on
            innovation(ii,:) = innov_forcast;
        end
    end

    if conditional ==1
        innovation_1 = err(:,t1+1:T); %zeros(size(D,2),LL);
        %innovation_1(find(taushock==1),1:4) = err(1,find(date==1999.0):find(date==1999.75)) ; %innovations for shock 1 are set equal to their value in 1999; alternatively, we can set directly the value of innovations (e.g. [0.1 0.1 0.1 0.1])
        
        %-----2000 scenario
        innovation_1(8,1:5) = err(8,find(date==2000.25):find(date==2001.25));
        innovation_1(9,1:5) = err(9,find(date==2000.25):find(date==2001.25));
        innovation_1(12,1:5) = err(12,find(date==2000.25):find(date==2001.25));
        %-----
        
        %----1998 scenario
%         innovation_1(8,1:3) = err(8,find(date==1998.5):find(date==1999.0));
%         innovation_1(9,1:3) = err(9,find(date==1998.5):find(date==1999.0));
%         innovation_1(12,1:3) = err(12,find(date==1998.5):find(date==1999.0));        
        %------------
        innovation = innovation + innovation_1;
    end
    if conditional ==2
        forecastkalman_input %load the file containing the conditioning assumptions; used only for conditional=2,3,4
        innovation = innovation + innovation_counter; %innovation_counter is defined in forecastkalman_input.m
    end

elseif conditional == 3 || conditional == 4
        
    %forecastkalman_input %load the file containing the conditioning assumptions; used only for conditional=2,3,4
    forecastkalman_input_WGFjune08_uncertainty
    %forecastkalman_input_ComparingModels
    
    innovation = err(:,t1+1:T);
    
    innovation = innovation + innovation_counter; %innovation_counter is defined in forecastkalman_input.m
    
end

BD = [B1*D; zeros(size(B1,1),size(D,2)); D];
[VYhat,Yhat,Yhat_] = forkalman(F,Q,xsmooth,Vsmooth,H,HH,R,alf,tauvar,BD,innovation,t1,LL);


if conditional ==2 || conditional ==3 || conditional ==4
    
    LLL = size(ybar,2);
    if LLL > LL
        error('(forecastkalman1) the length of conditioning variables is too long')
    end

    if conditional == 4
        %error('fatal (forecastkalman1) conditional =4 and the code needs to be checked')
        
        % -- 0.) obtain smoothed state as initial state for comparability with conditional = 3
        [xsmooth_c,Vsmooth_check] = kalman_smoother(Y, F, H, Q, R, initxi, P,alf(tauvar')); %run the smoother up to T=t1+LL to get the shocks
        
        % -- 1.) get unconditional forecast as in unconditional = 2
        innovation = zeros(size(D,2),LL);
        BD = [B1*D; zeros(size(B1,1),size(D,2)); D];
        [VYhat,Yhat,Yhat_uncon] = forkalman(F,Q,xsmooth_c,Vsmooth,H,HH,R,alf,tauvar,BD,innovation,t1,LL);

        % -- 2.) get the innovations from conditional forecast as in unconditional = 3
        [xsmooth_c,Vsmooth_check] = kalman_smoother(Y, F, H, Q, R, initxi, P,alf(tauvar')); %run the smoother up to T=t1+LL to get the shocks
        Xhht = HH*xsmooth_c+ alf*ones(1,size(xsmooth_c,2)) ;

        s = [2*l_z+1:2*l_z+l_psi];
        for ii = 2:T
            err(:,ii) = xsmooth_c(s,ii)-F(s,s)*xsmooth_c(s,ii-1);
        end
        err(:,1) = xsmooth_c(s,1);

        BD_c = [B1; zeros(size(B1,1),size(B1,2)); eye(size(D,1),size(B1,2))];
        innovation = err(:,t1+1:T); %note that err corresponds to D*innovation. Thus BD above has been defined accordingly
        [VYhat_check,Yhat,Yhat_] = forkalman(F,Q,xsmooth_c,Vsmooth_check,H,HH,R,alf,tauvar,BD_c,innovation,t1,LL);
        if max(max(Yhat_-Xhht)) > 10e-8
            error('fatal (forecastkalman) innovations are wrong')
        end
        innovation = innovation([1:2:length(innovation)],:); %recall that shocks come in two-pieces each
        BD = [B1*D; zeros(size(B1,1),size(D,2)); D]; %BD gets redefined here to account that in previous line innovation has ben shrinked

        % --- 3.) from now on same structure as for conditional = 2 and conditional = 3; Note: Yhat_uncon is the reference point
        Yhat_1 = Yhat_uncon(aa,t1+1:t1+LL)';
        Yhat_1 = reshape(Yhat_1,size(Yhat_1,1)*size(Yhat_1,2),1);
        rr = reshape(ybar',size(ybar,1)*size(ybar,2),1) - Yhat_1;
        
        nn = length(aa); % no. of constraints
        kk = length(bb); % number of free shocks
        nstates = size(HH,2);
        nvars   = size(HH,1);
        nshocks = size(BD,2);
        GG = zeros(LL*nn,nshocks*LL);
        
        bbb = [];
        for jj =1:kk
            bbb = [bbb find(taushock==bb(jj))]; %we need it below to remove the columns of the shocks that are constrained to be zero
        end
        % --  define G matrix.
        for j=1:nn
            HBD = HH*BD;
            GG(1+(j-1)*LL,1:nshocks) = HBD(aa(j),:);
            if LL >= 2
                for i = 2:LL
                    HBD = HH*F^(i-1)*BD;
                    GG(i+(j-1)*LL,1:nshocks*i) = [HBD(aa(j),:)  GG(i-1+(j-1)*LL,1:nshocks*(i-1)) ];
                end
            end
        end
        
                
        % -- 4.) rearrange shocks by creating selection matrix to say which shocks are constrained
        ncshocks = nshocks - kk;
        Smat     = zeros(ncshocks - kk,nshocks);
        counter  = 0;
        scheck = [];
        for jkl = 1:ncshocks
            counter = counter + 1;
            while isempty(find(bb==taushock(counter)))==0
                counter = counter+1;
            end
            scheck (jkl,1) = counter;
            Smat(jkl,counter) = 1;
        end
        Smat = Smat';
        Smat = kron(eye(LL), Smat);
        GS = GG*Smat;

        % -- also create selection matrix for unconstrained shocks
        Stildemat = zeros(kk,nshocks);
        counter = 0;
        for jkl = 1:kk
            counter = counter + 1;
            while isempty(find(bb==taushock(counter)))==1
                counter = counter+1;
            end
            Stildemat(jkl,counter) = 1;
        end
        Stildemat = Stildemat';
        Stildemat = kron(eye(LL), Stildemat);
        GStilde = GG*Stildemat;

        % -- set up Gtilde
        Gtilde = [GS,GStilde];
        sbar = [];
        for jkl = 1:LL
            sbar = [sbar; innovation(scheck,jkl)];
        end

        % -- 5.) max-likelihood value for shocks given constraints
        shocksuncon = GStilde'*inv(GStilde*GStilde')*(rr-GS*sbar); 
        innovation_ = reshape(shocksuncon,kk,LL);
        % -- 6.) replace the unconstrained innovations in innovation-vector
        innovation(bbb,:) = innovation_;
        [VYhat,Yhat,Yhat_] = forkalman(F,Q,xsmooth_c,Vsmooth,H,HH,R,alf,tauvar,BD,innovation,t1,LL);
        %Yhat4 = Yhat; Yhat_4 = Yhat_; innovation4 = innovation;
        %save 4check_K Yhat_4 innovation4;
    end

    if conditional == 2 || conditional == 3
        Yhat_1 = Yhat_(aa,t1+1:t1+LLL)';
        Yhat_1 = reshape(Yhat_1,size(Yhat_1,1)*size(Yhat_1,2),1);

        rr = reshape(ybar',size(ybar,1)*size(ybar,2),1) - Yhat_1;


        bb_ = []; %following lines compute bbb, which specifies the innovations that we want to allow to be non-zero
        for ij = 1:size(bb,1)
            bb_ = [bb_ bb{ij,1}];
        end
        ix=1;
        d=0; %we initialise d to 0 as it was used before
        for ii = 1:length(taushock)
            [n_bb,I_bb]  = max(bb_==taushock(ii));
            if n_bb==1 && parstoch(taushock(ii))==0  || n_bb==1 && bb{I_bb,2}==1
                d(ix)=1;
            end
            if parstoch(taushock(ii)) == 0
                ix=ix+1;
            else
                if bb{I_bb,3}==1
                    d(ix+1)=1;
                end
                ix=ix+2;
            end
        end
        bbb = find(d==1);
        kk=length(bbb);
        
        nn = length(aa);
        GG = zeros(LLL*nn,kk*LLL);

        for j=1:nn
            HBD = HH*BD;
            GG(1+(j-1)*LLL,1:kk) = HBD(aa(j),bbb);
            if LLL >= 2
                for i = 2:LLL
                    HBD = HH*F^(i-1)*BD;
                    GG(i+(j-1)*LLL,1:kk*i) = [HBD(aa(j),bbb)  GG(i-1+(j-1)*LLL,1:kk*(i-1)) ];
                end
            end
        end

        diag_shocks = 1; %=1 assume covariance matrix of exogenous disturbances is identity; =0 assume it is full. In the latter case, empirical estimates are used
        if diag_shocks==1
            
            innovation_ = GG'/(GG*GG')*rr;  %GG'*inv(GG*GG')*rr;
            
        elseif diag_shocks ==0
            load([outfolder '\maxlike'], 'covmat')
            covmat_ = kron(covmat(bbb,bbb),eye(LLL));
            innovation_ = covmat_*GG'/(GG*covmat_*GG')*rr;
        end

        innovation_ = reshape(innovation_,kk,LLL);

        innovation_new =innovation;
        innovation_new(bbb,1:LLL) = innovation(bbb,1:LLL)+innovation_;
        [VYhat,Yhat,Yhat_] = forkalman(F,Q,xsmooth,Vsmooth,H,HH,R,alf,tauvar,BD,innovation_new,t1,LL); %we use here xsmooth_c, i.e. we assume that there is no uncertainty regarding the state of the economy
        
        rob=0;
        if rob==1
            LLL=LL;
            xx_inn = innovation_(1:LLL);
            optionals = optimset('LevenbergMarquardt','on','Display','iter','TolFun',1e-8,'TolX',1e-8,'MaxFun',300,'Diagnostics','on','MaxFunEvals',300);
            [xx_inn_new,fval,exitflag] = fminsearch(@findinnovations,xx_inn,optionals,F,Q,xsmooth,Vsmooth,H,HH, ...
                    R,alf,tauvar,BD,innovation,t1,LL,bbb,Y,LLL);

            %option(4) = 30; %maximum number of iterations (15000 by default)
            %option(5) = 1;  %in order to print intermediate results
            %[xx_inn_new,fval,options] = solvopt(xx_inn,'findinnovations',[],option,[],[],F,Q,xsmooth_c,Vsmooth,H,HH, ...
            %                                          R,alf,tauvar,BD,innovation,t1,LL,bbb,Y,LLL);

            innovation_new(bbb,1:LLL) = innovation(bbb,1:LLL)+xx_inn_new;
            [VYhat,Yhat,Yhat_] = forkalman(F,Q,xsmooth,Vsmooth,H,HH,R,alf,tauvar,BD,innovation_new,t1,LL); %we use here xsmooth_c, i.e. we assume that there is no uncertainty regarding the state of the economy
        end
    end
end


%------- the following code converts the variables in y-o-y changes or levels
plot_data_mean= 0;
idat=0; %set =1 when prepare_short below works with the actual data. In that case, we want to do some smoothing on consumption before computing the marginal utility of consumption. Otherwise mu will go negative
if plot_data_mean==1  %remove estimated mean and add mean of the data
    Yhat_ = Yhat_ - mean((Yhat_(1:l_xxx,:))')'*ones(1,size(Yhat_,2)) + meanxxx*ones(1,size(Yhat_,2));
elseif plot_data_mean==2
    Yhat_ = Yhat_ - alf*ones(1,size(Yhat_,2));
end
trendm1=zeros(size(Yhat_,2),1); %set trend to zero to avoid adding up the trend n times in the analysis of shocks below, where n is the number of shocks
trendm3=zeros(size(Yhat_,2),1);
[laborwedge,laborwedgea,effwedge,net,dmoney3,dmoney1,dinvest,dout,infl,dwage,dcons,Spread1,money1,money3, ...
    output,invest,cons,wage,price,hours,capacity,btott,dbtott,Rm_series,Re_series,Pe_series,govc,dgovc,idef,didef, ...
    oilp,doilp,Spread2,dnet,reserves,dreserves] ...
    = prepare_short(Yhat_,mm,trendm3,trendm1,size(Yhat_,2),fdiff,alpha,b,beta,idat);

if plot_levels == 1 %levels
    XXXt = [net;price;hours;btott;output;wage;invest;money1;money3;cons;Pe_series;Spread1;Rm_series;Re_series;capacity;govc;idef;oilp;Spread2;reserves];
elseif plot_levels == 0 %ratios
    XXXt = Yhat_;
elseif plot_levels == 2 %year-on-year growth rates
    XXXt = [dnet;infl;hours;dbtott;dout;dwage;dinvest;dmoney1;dmoney3;dcons;Pe_series;Spread1;Rm_series;Re_series;capacity;dgovc;didef;doilp;Spread2;dreserves];
end

Yhat_ = XXXt;
