%-------------------------------------------------------------------------
%-------------------------------------------------------------------------
%Specify in this file the values of conditional variables and/or conterfactual innovations
%It applies only to the case conditional=2 and conditional=3 (recall that conditional is set in forecastkalman1)
%This file is loaded up in forecastkalman1
%-------------------------------------------------------------------------

innovation_counter = zeros(size(D,2),LL); %do not modify this


%-------------------------------------------------------------------------
%   SET VALUES OF INNOVATIONS                  
%-------------------------------------------------------------------------
innov_counter=1; %innov_counter=1, if you want to set counterfactual values for innovations; =0 otherwise 

if innov_counter ==1
    %the first term on the rhs below is needed to zero out the existing innovations you select and the second term is to replace it with counterfactual values you provide
    %innovation_counter(8,1:4) = -err(8,find(date==2007.5):find(date==2008.25))  - 2*err(9,find(date==2006.0):find(date==2006.75));
    innovation_counter(12,:) = -err(12,find(date==2007.5):find(date==2009.75))  -[0.2*err(12,find(date==1998.75))*ones(1,1) 0.5*err(12,find(date==1998.75))*ones(1,3) 0.45*err(12,find(date==1998.75))*ones(1,6)];
    innovation_counter(9,:) = -err(9,find(date==2007.5):find(date==2009.75))  +[0.2*err(9,find(date==2002.25))*ones(1,3) 0.4*err(9,find(date==2002.25))*ones(1,2) -0.1*err(9,find(date==2002.25))*ones(1,5)];    
    %innovation_counter(11,:) = [0 0 0 -0.5 -0.5 -0.2 -0.2 -0.2 -0.2 -0.2];%[0 0 0 0 0 0 -0.3 -0.5 -0.6 -0.5];
    %innovation_counter(5,:) = -err(5,find(date==2007.5):find(date==2009.75)) + [-0.0255 -.01881 -.006677 0.0069 -.00083 0.0074 -.00064 0.011 0.0046 0.0133 ] ;
end
%-------------------------------------------------------------------------



%-------------------------------------------------------------------------
% SET ybar AND SPECIFIES WHICH VARIABLES AND INNOVATIONS YOU WANT TO USE
%-------------------------------------------------------------------------
%ybar is a matrix containing the values of constrained variables. Dimension: nnxLLL, where nn is the No. of constrained variables. LLL can be =<LL

ybar =  [%Y(find(tauvar==14),t1+1:end);  %Re --ECB Projections
         %mean(Y(find(tauvar==11),find(date==2005.25):find(date==2006.25)))*ones(1,LL);
         %mean(Y(find(tauvar==9),find(date==2006.0):find(date==2006.75))+Y(find(tauvar==2),find(date==2006.0):find(date==2006.75)) )*ones(1,LL);
         %-0.003722153123438*ones(1,LL)];
         %[Y(find(tauvar==5),t1+1:t1+6) Y(find(tauvar==5),t1+7:t1+LL)-0.0005];
         Y(find(tauvar==1),t1+1:end)+Y(find(tauvar==2),t1+1:end)]; 
         %Y(find(tauvar==18),t1+1:end)];

%Y(find(tauvar==14),t1+1:end);
%ones(1,LL)*0.008*1.3; %Constant DM1
%Y(find(tauvar==9),t1+1:end); %DM3  --BVAR + ECB Projections

aa = [ 22  ]; %location of the variables you want to constrain, e.g. aa=[5 14], whose value is defined in ybar. numbering refers to location in full set of observables, not in tauvar
%20: nominal M1 growth, 21: nominal M3 growth; 22= nominal net-worth growth; 23= nominal oil price growth

bb = { %6,  1, 0;
       %9,  1, 0;
       17, 1, 0};
       %24, 1, 0};  %1st column: # of the shock (in full list, not in taushock); 2nd column: patriot; 3rd column is signal; if shock does NOT have signal, 2nd column=1 and 3rd column 0
       

%bb = {1,  1, 0; 
%      6,  1, 0;
%      7,  1, 0;
%      9,  1, 0;
%      13, 1, 0;
%      16, 1, 0;
%      17, 1, 1;
%      18, 1, 0;
%      21, 1, 0;
%      22, 1, 0;
%      23, 1, 0;
%      24, 1, 0;
%      25, 1, 0};

%when you want to condition on MPE external assumptions activate the following two lines
% aa=[12 14 22 23]; 
% bb= {17, 1, 1;
%      19, 1, 0;
%      24, 1, 0;
%      25, 1, 0};
% ybar = [Y(find(tauvar==12),t1+1:end); Y(find(tauvar==14),t1+1:end); Y(find(tauvar==1),t1+1:end)+Y(find(tauvar==2),t1+1:end);  Y(find(tauvar==18),t1+1:end)+Y(find(tauvar==2),t1+1:end)];


%-------unchanged rate
% ybar =  [Y(find(tauvar==14),t1+1:end);  %Re --MPE
%          mean(Y(find(tauvar==9),t1-5:t1-2)+Y(find(tauvar==2),t1-5:t1-2))*ones(1,LL)];
% aa = [14 21]; 
% bb = { 9, 1, 0;
%       19, 1, 0};  
%------       


%------high M3 and Credit growth
% innovation_counter = zeros(size(D,2),LL);
%    % ybar = [Y(find(tauvar==9),find(date==2007.5))*ones(1,LL) + Y(find(tauvar==2),find(date==2007.5))*ones(1,LL);
%    %         Y(find(tauvar==4),find(date==2007.5))*ones(1,LL) + Y(find(tauvar==2),find(date==2007.5))*ones(1,LL) ];
% ybar= [0.01165*ones(1,LL);
%        0.00998*ones(1,LL)];
% aa = [21 24]; 
% bb = { 9, 1, 0;
%       17, 1, 1};  
%--------
       




