function [Xt,XXt] = gen(err,zinitm1,psiinitm1,rho,A,B1,taum,taub,taus,T,trendm1,trendm3,mm, ...
                         fdiff,alpha,b,beta,idat,plot_levels)

psi(:,1) = rho*psiinitm1 + err(:,1);
z(:,1) = A*zinitm1(:,1) + B1*psi(:,1);
Xt(:,1) = taum*z(:,1) + taub*zinitm1(:,1) + taus*psi(:,1);

for ii = 2:T
    psi(:,ii) = rho*psi(:,ii-1) + err(:,ii);
    z(:,ii) = A*z(:,ii-1) +  B1*psi(:,ii);
    Xt(:,ii) = taum*z(:,ii) + taub*z(:,ii-1) + taus*psi(:,ii);
end

xxxsmooth = [z;[zinitm1, z(:,1:end-1)];psi];

%-------------------------------------------------------------------------
trendm1=zeros(size(trendm1)); %set trend to zero to avoid adding up the trend n times in the analysis of shocks below, where n is the number of shocks
trendm3=zeros(size(trendm3)); 
[laborwedge,laborwedgea,effwedge,net,dmoney3,dmoney1,dinvest,dout,infl,dwage,dcons,Spread1,money1,money3, ...
        output,invest,cons,wage,price,hours,capacity,btott,dbtott,Ra_series,Re_series,Pe_series,govc,dgovc,idef,didef, ...
        oilp,doilp,Spread2,dnet,reserves,dreserves] ...
    = prepare_short(Xt,mm,trendm3,trendm1,T,fdiff,alpha,b,beta,idat);

if plot_levels == 1 %levels                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            
    XXt = [net;price;hours;btott;output;wage;invest;money1;money3;cons;Pe_series;Spread1;Ra_series;Re_series;capacity;govc;idef;oilp;Spread2;reserves];
elseif plot_levels == 0 %leave data as they are
    XXt = Xt;
elseif plot_levels == 2 %year-on-year growth rates
    XXt = [dnet;infl;hours;dbtott;dout;dwage;dinvest;dmoney1;dmoney3;dcons;Pe_series;Spread1;Ra_series;Re_series;capacity;dgovc;didef;doilp;Spread2;dreserves];
end
