% this program loads the data
addpath .\data

if country==1

    first_avb_obs = 1980.25; %first available observation in the sample
    
    [XXXr,XXXd,trendm1,trendm3,trendiy,date] = eurodata8(first_avb_obs,start_estimation,end_estimation,calvohours,user,outfolder); 
    
elseif country==2 | country==3
    first_avb_obs = 1959.75;
    [XXXr,XXXd,trendm1,trendm3,trendiy,date] = usdata(first_avb_obs,start_estimation,end_estimation,user,outfolder);
end

if fdiff == 0
    XXX = XXXr;
elseif fdiff == 1
    XXX = XXXd;
end

if fdiff == 1 & detrending ~= 0
    %disp('fatal (loaddata) you are trying to detrend data but you have selected data in first differences')
end

if detrending == 1
    Y=XXX(:,1);
    X=[ones(size(XXX,1),1) [1:size(XXX,1)]'];
    bet=(X'*X)\(X'*Y);
    trend1  = X(:,2)*bet(2,1);
    XXX(:,1)=Y-trend1;
    
    Y=XXX(:,2);
    X=[ones(size(XXX,1),1) [1:size(XXX,1)]'];
    bet=(X'*X)\(X'*Y);
    trend2  = X(:,2)*bet(2,1);
    XXX(:,2)=Y-trend2;
        
    Y=XXX(:,4);
    X=[ones(size(XXX,1),1) [1:size(XXX,1)]'];
    bet=(X'*X)\(X'*Y);
    trend4  = X(:,2)*bet(2,1);
    XXX(:,4)=Y-trend4;
    
    Y=XXX(:,6);
    X=[ones(size(XXX,1),1) [1:size(XXX,1)]'];
    bet=(X'*X)\(X'*Y);
    trend6  = X(:,2)*bet(2,1);
    XXX(:,6)=Y-trend6;
    
    Y=XXX(:,7);
    X=[ones(size(XXX,1),1) [1:size(XXX,1)]'];
    bet=(X'*X)\(X'*Y);
    trend7  = X(:,2)*bet(2,1);
    XXX(:,7)=Y-trend7;
    
    Y=XXX(:,10);
    X=[ones(size(XXX,1),1) [1:size(XXX,1)]'];
    bet=(X'*X)\(X'*Y);
    trend10  = X(:,2)*bet(2,1);
    XXX(:,10)=Y-trend10;

    Y=XXX(:,14);
    X=[ones(size(XXX,1),1) [1:size(XXX,1)]'];
    bet=(X'*X)\(X'*Y);
    trend14  = X(:,2)*bet(2,1);
    XXX(:,14)=Y-trend14;

    Y=XXX(:,9);
    X=[ones(size(XXX,1),1) [1:size(XXX,1)]'];
    bet=(X'*X)\(X'*Y);
    trendm3  = X(:,2)*bet(2,1);
    XXX(:,9)=Y-trendm3;
    
    Y=XXX(:,8);
    X=[ones(size(XXX,1),1) [1:size(XXX,1)]'];
    bet=(X'*X)\(X'*Y);
    trendm1  = X(:,2)*bet(2,1);
    XXX(:,8)=Y-trendm1;
    
elseif detrending ==2
    Y=XXX(:,1);
    YY=hpfilt(length(Y),1600);
    
    XXX(:,1)=YY*Y;
    
    Y=XXX(:,2);
    XXX(:,2)=YY*Y;
    
    Y=XXX(:,3);
    XXX(:,3)=YY*Y;
    
    Y=XXX(:,4);
    XXX(:,4)=YY*Y;
    
    Y=XXX(:,5);
    XXX(:,5)=YY*Y;
    
    Y=XXX(:,6);
    XXX(:,6)=YY*Y;
    
    Y=XXX(:,7);
    XXX(:,7)=YY*Y;
    
    Y=XXX(:,10);
    XXX(:,10)=YY*Y;
    
    Y=XXX(:,11);
    XXX(:,11)=YY*Y;

    Y=XXX(:,12);
    XXX(:,12)=YY*Y;

    Y=XXX(:,14);
    XXX(:,14)=YY*Y;
    
    Y=XXX(:,15);
    XXX(:,15)=YY*Y;
    
    Y=XXX(:,17);
    XXX(:,17)=YY*Y;

    Y=XXX(:,9);
    XXX(:,9)=YY*Y;
    
    Y=XXX(:,8);
    XXX(:,8)=YY*Y;
    
elseif detrending ==3
    %[dinfl,tinfl]=Hpfast(XXX(:,2),1600);
    %XXX(:,2)=dinfl;
    %[dre,tre]=Hpfast(XXX(:,14),1600);
    %XXX(:,14)=dre;
    Y = XXX(find(date==start_estimation):find(date==2001.5),9); %Y=XXX(:,9);
    X = [ones(length(find(date==start_estimation):find(date==2001.5)),1) [1:find(date==2001.5)]']; %X=[ones(size(XXX,1),1) [1:size(XXX,1)]'];
    bet=(X'*X)\(X'*Y);
    trendm3  = [1:find(date==end_estimation)]'*bet(2,1); %X(:,2)*bet(2,1);
    XXX(:,9) = XXX(find(date==start_estimation):find(date==end_estimation),9) -trendm3; %Y-trendm3;
    
    Y = XXX(find(date==start_estimation):find(date==2001.5),8); %Y=XXX(:,8);
    X=[ones(length(find(date==start_estimation):find(date==2001.5)),1) [1:find(date==2001.5)]']; %X=[ones(size(XXX,1),1) [1:size(XXX,1)]'];
    bet=(X'*X)\(X'*Y);
    trendm1  = [1:find(date==end_estimation)]'*bet(2,1); %X(:,2)*bet(2,1);
    XXX(:,8) = XXX(find(date==start_estimation):find(date==end_estimation),8) -trendm1; %Y-trendm1;
end

Quarters=size(XXX,1);
if length(date) ~= Quarters
    error('fatal (loaddata) dates different from Quarters')
end

XXX=XXX';

qwh=diag([1 1 1 1 1 1 1 1 1 1 1/400 1/400  1/400 1/400 1 1 1 1 1/400 1]);

XXX=qwh*XXX;

nXXX=size(XXX,1);

[Xdat,mm,meanxxx] = demeandata(XXX,find(date==start_estimation),find(date==end_estimation),find(date==end_estimation_means),init_kalman,demean,mm,entr,country,pi,Re,R,Ra);
alp = max(tauvar==16);
alp1= max(taushock==13);
if alp ==1 & alp1 ~=1
    error('(loaddata) you have included g as observable but it is not included in taushock')
end
alp = max(tauvar==17);
alp1 = max(taushock==7);
if alp ==1 & alp1 ~=1
    error('(loaddata) you have included investment deflator as observable but muup is not included in taushock')
end
alp = max(tauvar==18);
alp1 = max(taushock==24);
if alp ==1 & alp1 ~=1
    error('(loaddata) you have included oil price as observable but tau0 is not included in taushock')
end

I15=eye(nXXX);
J = I15(tauvar,:);

if irun==7
    Xdat_dyn = exp(Xdat); %we take exponentials before exporting to Dynare, as it will take logs of the data when you will select loglinear specification
    Xdat_dyn = (J*Xdat_dyn)';
    save(name_file_dyn,'Xdat_dyn', '-append');
end

Xdat = J*Xdat;

