function maketable_modelvariance(std_data,Var_cmr,Var_fish,Var_bgg,Var_sw,Var_b, ...
        name,namevariable,tauvar_cmr,tauvar_bgg,tauvar_b,tauvar_fish,tauvar_sw,outfolder,parstoch)

n_col= length(tauvar_cmr); 

namemodels = 'Benchmark Model';
%inflate the size of Var in alternative models in order to make it same size as benchmark model
if isempty(Var_fish)==0
    [Var_fish]=maketable_modelvariance_util(Var_fish,tauvar_fish,tauvar_cmr);
    namemodels = char(namemodels,'Benchmark, no Fisher Effect');
end
if isempty(Var_bgg)==0
    [Var_bgg]=maketable_modelvariance_util(Var_bgg,tauvar_bgg,tauvar_cmr);
    namemodels = char(namemodels,'Financial Accelerator');
end
if isempty(Var_b)==0
    [Var_b]=maketable_modelvariance_util(Var_b,tauvar_b,tauvar_cmr);
    namemodels = char(namemodels,'No Entrepreneurs');
end
if isempty(Var_sw)==0
    [Var_sw]=maketable_modelvariance_util(Var_sw,tauvar_sw,tauvar_cmr);
    namemodels = char(namemodels,'Simple Model');
end

lengthxx = size(namemodels,1);

ncol = n_col+1; %additional column allows for models' names

fid = fopen([outfolder '\' name],'w');

fprintf(fid,' \\documentclass{article} \n');
fprintf(fid,' %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% \n');
fprintf(fid,' \\usepackage{amsfonts} \n');
fprintf(fid,' \\usepackage{amsmath} \n');

fprintf(fid,' \\setcounter{MaxMatrixCols}{10} \n');
fprintf(fid,' %%TCIDATA{OutputFilter=LATEX.DLL} \n');
fprintf(fid,' %%TCIDATA{Version=4.10.0.2345} \n');
fprintf(fid,' %%TCIDATA{Created=Thursday, October 31, 2002 05:55:21} \n');
fprintf(fid,' %%TCIDATA{LastRevised=Thursday, October 31, 2002 06:08:51} \n');
fprintf(fid,' %%TCIDATA{<META NAME="GraphicsSave" CONTENT="32">} \n');
fprintf(fid,' %%TCIDATA{<META NAME="DocumentShell" CONTENT="Standard LaTeX\\Standard LaTeX Article">} \n');
fprintf(fid,' %%TCIDATA{CSTFile=40 LaTeX article.cst} \n');

fprintf(fid,' \\newtheorem{theorem}{Theorem} \n');
fprintf(fid,' \\newtheorem{acknowledgement}[theorem]{Acknowledgement} \n');
fprintf(fid,' \\newtheorem{algorithm}[theorem]{Algorithm} \n');
fprintf(fid,' \\newtheorem{axiom}[theorem]{Axiom} \n');
fprintf(fid,' \\newtheorem{case}[theorem]{Case} \n');
fprintf(fid,' \\newtheorem{claim}[theorem]{Claim} \n'); 
fprintf(fid,' \\newtheorem{conclusion}[theorem]{Conclusion} \n');
fprintf(fid,' \\newtheorem{condition}[theorem]{Condition} \n');
fprintf(fid,' \\newtheorem{conjecture}[theorem]{Conjecture} \n');
fprintf(fid,' \\newtheorem{corollary}[theorem]{Corollary} \n'); 
fprintf(fid,' \\newtheorem{criterion}[theorem]{Criterion} \n');
fprintf(fid,' \\newtheorem{definition}[theorem]{Definition} \n');
fprintf(fid,' \\newtheorem{example}[theorem]{Example} \n');
fprintf(fid,' \\newtheorem{exercise}[theorem]{Exercise} \n'); 
fprintf(fid,' \\newtheorem{lemma}[theorem]{Lemma} \n');
fprintf(fid,' \\newtheorem{notation}[theorem]{Notation} \n');
fprintf(fid,' \\newtheorem{problem}[theorem]{Problem} \n');
fprintf(fid,' \\newtheorem{proposition}[theorem]{Proposition} \n');
fprintf(fid,' \\newtheorem{remark}[theorem]{Remark} \n');
fprintf(fid,' \\newtheorem{solution}[theorem]{Solution} \n'); 
fprintf(fid,' \\newtheorem{summary}[theorem]{Summary} \n');
fprintf(fid,' \\newenvironment{proof}[1][Proof]{\\noindent\\textbf{#1.} }{\\ \\rule{0.5em}{0.5em}} \n');
fprintf(fid,' \\input{tcilatex} \n'); 

fprintf(fid,' \\begin{document} \n');

fprintf(fid,' \\begin{equation*} \n');

nn = '|l||';
for ii=1:ncol-1
    nn = [nn 'c|'];
end
fprintf(fid,[' \\begin{tabular}{' nn '} \\hline \n']);

fprintf(fid,[' \\multicolumn{' num2str(ncol) '}{|c|}{Table: Model-Implied Standard Deviation and Standard Deviation of the Corresponding Empirical Variables (in percent) } \\\\ [1.5ex] \\hline \n ']);

%fprintf(fid,' keyboard  \n');


namevariable_ = deblank(namevariable(tauvar_cmr(1),1:10));
for ii=2:ncol-1
    namevariable_ = [namevariable_ ', & ' deblank(namevariable(tauvar_cmr(ii),1:10))];
end
namevariable_ = ['multicolumn{1}{|l||}{}& ' namevariable_];

fprintf(fid, [' \\'  namevariable_ ' \\\\  [1.5ex] \\hline \\hline \n']);

rowii = num2str(std_data(1),2);
for jj=2:ncol-1
    rowii = [rowii ' & ' num2str(std_data(jj),2)];
end
rowii = ['multicolumn{1}{|l||}{Sample Data} & ' rowii];

fprintf(fid,[' \\' rowii   ' \\\\  \\hline \n']);



rowii = num2str(Var_cmr(1),2);
for jj=2:ncol-1
    rowii = [rowii ' & ' num2str(Var_cmr(jj),2)];
end
rowii = ['multicolumn{1}{|l||}{' namemodels(1,:) '} & ' rowii];

fprintf(fid,[' \\' rowii   ' \\\\  \\hline \n']);

jk=2;
if isempty(Var_fish)==0
    if isnan(Var_fish(1))==1
        rowii = '--';
    else
        rowii =  num2str(Var_fish(1),2);
    end
    for jj=2:ncol-1
        if isnan(Var_fish(jj))==1
            rowii = [rowii ' & ' '--'];
        else
            rowii = [rowii ' & ' num2str(Var_fish(jj),2) ];
        end
    end
    rowii = ['multicolumn{1}{|l||}{' namemodels(jk,:) '} & ' rowii];
    fprintf(fid,[' \\' rowii   ' \\\\ \\hline \n']);
    jk = jk+1;
end
if isempty(Var_bgg)==0
    if isnan(Var_bgg(1))==1
        rowii = '--';
    else
        rowii =  num2str(Var_bgg(1),2);
    end
    for jj=2:ncol-1
        if isnan(Var_bgg(jj))==1
            rowii = [rowii ' & ' '--'];
        else
            rowii = [rowii ' & ' num2str(Var_bgg(jj),2) ];
        end
    end
    rowii = ['multicolumn{1}{|l||}{' namemodels(jk,:) '} & ' rowii];
    fprintf(fid,[' \\' rowii   ' \\\\ \\hline  \n']);
    jk = jk+1;
end
if isempty(Var_b)==0
    if isnan(Var_b(1))==1
        rowii = '--';
    else
        rowii =  num2str(Var_b(1),2);
    end
    for jj=2:ncol-1
        if isnan(Var_b(jj))==1
            rowii = [rowii ' & ' '--'];
        else
            rowii = [rowii ' & ' num2str(Var_b(jj),2) ];
        end
    end
    rowii = ['multicolumn{1}{|l||}{' namemodels(jk,:) '} & ' rowii];
    fprintf(fid,[' \\' rowii   ' \\\\ \\hline \n']);
    jk = jk+1;
end
if isempty(Var_sw)==0
    if isnan(Var_sw(1))==1
        rowii = '--';
    else
        rowii =  num2str(Var_sw(1),2);
    end
    for jj=2:ncol-1
        if isnan(Var_sw(jj))==1
            rowii = [rowii ' & ' '--'];
        else
            rowii = [rowii ' & ' num2str(Var_sw(jj),2) ];
        end
    end
    rowii = ['multicolumn{1}{|l||}{' namemodels(jk,:) '} & ' rowii];
    fprintf(fid,[' \\' rowii   ' \\\\ \\hline \n']);
    jk =jk+1;
end

fprintf(fid,' \\end{tabular}%% \n');
fprintf(fid,' \\end{equation*}%% \n');

fprintf(fid,' {\\small Note: }{\\small }\n');

fprintf(fid,' \\end{document} \n');

fclose(fid);