% %b
% [1,0.6,0.2];
% %Fomegabar
% [1,0.026,0.02];
% %mu
% [1,0.0999,0.1];
% %gamma
% [1,0.978,0.1];
%sigmaL
% [3,1,0.5];
%std of shocks
%[2,0.01,5];

% 
% [a__,b__] = betapar(0.026,0.01);
% roby=0.005:0.005:0.3; 
% for roby1=1:length(roby)
%   logf(roby1) = exp(logbetapdf(roby(roby1),a__,b__)); %exp(logigammapdf(roby(roby1),0.25,12)); %exp(lognormpdf(roby(roby1),1,0.2)); %
% end
% figure; plot(roby,logf)

if opt_routine ==1 %Matlab routine fminsearch
    
    optionals = optimset('LevenbergMarquardt','on','Display','iter','TolFun',1e-8,'TolX',1e-8,'MaxFun',10000,'Diagnostics','on','MaxFunEvals',10000);

    [xxnew,fval,exitflag] = fminsearch(@ssloglik,xx,optionals,par,taumat,her,Rb,Re,c,y,i,mb, w,l,k,n,pi,g,ev, ...
    taushock,Pe,G,Gp,omegabar,Rk,rk,Gs,fdiff,Xdat,J,ric,M,m1,currdep,Ra,dm,m3,demean,mm,parstoch,duration1,tauvar, ...
    tauvar2,size_a,size_b,prior,taushock1,gamma,alpha,R,ttt2,entr,taushock3,duration2,params,q,s,u,lambdaz,uzc,vn,Rm,btot,init_kalman);

elseif opt_routine ==2 %Matlab routine fminunc
    
    optionals = optimset('LevenbergMarquardt','on','Display','iter','TolFun',1e-8,'TolX',1e-8,'MaxFun',2500,'Diagnostics','on','MaxFunEvals',2500);

    [xxnew,fval,exitflag] = fminunc(@ssloglik,xx,optionals,par,taumat,her,Rb,Re,c,y,i,mb, w,l,k,n,pi,g,ev, ...
    taushock,Pe,G,Gp,omegabar,Rk,rk,Gs,fdiff,Xdat,J,ric,M,m1,currdep,Ra,dm,m3,demean,mm,parstoch,duration1,tauvar, ...
    tauvar2,size_a,size_b,prior,taushock1,gamma,alpha,R,ttt2,entr,taushock3,duration2,params,q,s,u,lambdaz,uzc,vn ,Rm,btot,init_kalman);

elseif opt_routine ==3 %Matlab routine fminunc supplying Hessian and Gradient
    
    optionals = optimset('LevenbergMarquardt','on','GradObj','on','Hessian','on','HessUpdate','bfgs','Display','iter','TolFun',1e-10,'TolX',1e-10,'MaxFun',100,'Diagnostics','on','MaxFunEvals',100);

    [xxnew,fval,exitflag,report,QQ,Hess] = fminunc(@sslogliktest,xx,optionals,par,taumat,her,Rb,Re,c,y,i,mb, w,l,k,n,pi,g,ev, ...
    taushock,Pe,G,Gp,omegabar,Rk,rk,Gs,fdiff,Xdat,J,ric,M,m1,currdep,Ra,dm,m3,demean,mm,parstoch,duration1,tauvar, ...
    tauvar2,size_a,size_b,prior,taushock1,gamma,alpha,R,ttt2,entr,taushock3,duration2,params,q,s,u,lambdaz,uzc,vn,Rm,btot,init_kalman);

    
elseif opt_routine ==4 %SolvOpt routine
    
    %options(3)=1.e-6;
    option(4) = 40; %maximum number of iterations (15000 by default)
    option(5) = 1;  %in order to print intermediate results
    
    [xxnew,fval,options] = solvopt(xx,'ssloglik',[],option,[],[],par,taumat,her,Rb,Re,c,y,i,mb, w,l,k,n,pi,g,ev, ...
    taushock,Pe,G,Gp,omegabar,Rk,rk,Gs,fdiff,Xdat,J,ric,M,m1,currdep,Ra,dm,m3,demean,mm,parstoch,duration1,tauvar, ...
    tauvar2,size_a,size_b,prior,taushock1,gamma,alpha,R,ttt2,entr,taushock3,duration2,params,q,s,u,lambdaz,uzc,vn,Rm,btot,init_kalman);

    
    if options(9) <0
        disp('(maximize) abnormal termination of optimisation')
    end
    
    if isnan(fval) == 1 | abs(imag(fval)) > .1e-0 
        error('fatal (maximize) optimized function value not a sensible number')
    end
    
    
elseif opt_routine ==5 | opt_routine ==6  | opt_routine ==7
    
    %set bounds on parameters to be estimated
    xx_lower = repmat(0,length(xx),1);  %lower bound on xx
    xx_upper = [repmat(1,7,1);repmat(1,14,1)];  %upper bound
    
    if opt_routine == 5
        addpath([curdrive 'optimisation\sims'])
        HH0   = eye(size(xx,1)); %initial value for the inverse Hessian.  Must be positive definite.
        grad = []; %If it's null, the program calculates a numerical gradient.  
        crit = 1.e-8; %Convergence criterion. Iteration will cease when it proves impossible to improve the function value by more than crit.
        n_iter = 2000; %Maximum number of iterations.
        [fval,xxnew,grd0,Hess,itct,fcount,retcodeh] = csminwelCon('ssloglik',xx,HH0,grad,crit,n_iter,xx_lower',xx_upper',1, ...
            par,taumat,her,Rb,Re,c,y,i,mb, w,l,k,n,pi,g,ev,taushock,Pe,G,Gp,omegabar,Rk,rk,Gs,fdiff,Xdat,J,ric,M,m1, ...
            currdep,Ra,dm,m3,demean,mm,parstoch,duration1,tauvar,tauvar2,size_a,size_b,prior,taushock1, ...
            gamma,alpha,R,ttt2,entr,taushock3,duration2,params,q,s,u,lambdaz,uzc,vn,Rm,btot,init_kalman); 
        
        
    elseif opt_routine == 6 %standard simulated annealing by Goffe
        
        %set inputs for simulated annealing
        vm_sa = 5*xx'; %step length vector. it should encompass the region of interest given starting value
        
        t_sa = 10; %initial temperature
        maxevl = 100000; %1000000000;
        ns_sa = 20;%20; %each element of x_sa is varied ns_sa times and the function value is evaluated each time. After all the evaluations for all the parameters have been done, each elemt of vm_sa is adjusted such that half of all function evaluations are accepted
        npar_sa = length(xx);
        nt_sa = 100; %max(100,5*npar_sa); %after nt_sa*ns_sa*npar_par evaluations have been made, there is a change in temperature
        rt_sa = 0.5;%0.85; %temperature reduction factor
        
        max_sa = 0; %=0 do minimisation; =1 do maximisation (note that the program performs maximisation. we set max_sa=0 because the value function (f) in ssloglik was set to -f, so we need to change the sign another time to revert to -(-f)=f
        eps_sa = 1.0e-6; %error tolerance
        neps_sa = 4; %value suggested by Goffe et al.
        c_sa = 2*ones(npar_sa,1); %controls the step length adjustment. suggested value =2
        iprint = 1; %=0, nothing printed; =1 summary results before each temperature reduction; =2 each new step length (vm); =3 each function evaluation. Suggested value =1
        
        [xxnew, fval_sa, nacc_sa, nfcnev_sa, nobds_sa, ier_sa, t_sa, vm_sa] = simul_annealing('ssloglik',xx',max_sa,rt_sa,eps_sa,ns_sa,nt_sa,neps_sa,maxevl,xx_lower,xx_upper,c_sa,iprint,t_sa,vm_sa, ...
            par,taumat,her,Rb,Re,c,y,i,mb, w,l,k,n,pi,g,ev,taushock,Pe,G,Gp,omegabar,Rk,rk,Gs,fdiff,Xdat,J,ric,M,m1, ...
            currdep,Ra,dm,m3,demean,mm,parstoch,duration1,tauvar,tauvar2,size_a,size_b,prior,taushock1, ...
            gamma,alpha,R,ttt2,entr,taushock3,duration2,params,q,s,u,lambdaz,uzc,vn,Rm,btot,init_kalman);
        
        xxnew=xxnew';
        
    elseif opt_routine ==7  %ASA (adaptive simulated annealing)
        
        cd([curdrive 'optimisation\adap_sim_anneal_ingber\asamin'])
        mex asamin.c asa.c -DUSER_ACCEPTANCE_TEST#TRUE -DUSER_ASA_OUT#TRUE -DASA_PRINT_MORE#TRUE -DSMALL_FLOAT#1.0E-35
        cd(cdir) 
        
        xtype = repmat(-1,length(xx),1); % xtype(i) = -1, if the i'th argument of toest is real; =1, if it is integer
        
        %set options for ASA
        %asamin('set','rand_seed',696969);
        asamin('set','user_initial_parameters',1);
        asamin('set','limit_acceptances',90000);
        asamin('set','limit_generated',900000);
        asamin('set','accepted_to_generated_ratio',1.0E-6);
        asamin('set','cost_parameter_scale_ratio',0.1);
        asamin('set','temperature_ratio_scale',1.0E-2);
        asamin('set','temperature_anneal_scale',1000);
        %asamin('set','acceptance_frequency_modulus',50);
        %asamin('set','maximum_cost_repeat',10);
        %asamin('set','reanneal_cost',5);
        %asamin('set','reanneal_parameters',0);
        
        asamin('set','asa_out_file','ASAreport.log');
        
        [f_val, xxnew, grad_asa, hessian_asa, state_asa] = asamin('minimize', 'ssloglik', xx', xx_lower, xx_upper, xtype, ...
            par,taumat,her,Rb,Re,c,y,i,mb, w,l,k,n,pi,g,ev,taushock,Pe,G,Gp,omegabar,Rk,rk,Gs,fdiff,Xdat,J,ric,M,m1, ...
            currdep,Ra,dm,m3,demean,mm,parstoch,duration1,tauvar,tauvar2,size_a,size_b,prior,taushock1, ...
            gamma,alpha,R,ttt2,entr,taushock3,duration2,params,q,s,u,lambdaz,uzc,vn,Rm,btot,init_kalman);
        
        xxnew = xxnew';
    end
end


if opt_routine ==1 | opt_routine==2 | opt_routine==3
    if exitflag == 0
        disp('(maximize) maximum number of function evaluations reached')
    elseif exitflag > 0
        disp('(maximize) converged to a solution')
    elseif exitflag < 0
        disp('(maximize) did not converge to a solution')
    end

    if isnan(fval) == 1 | abs(imag(fval)) > .1e-0
        error('fatal (maximize) optimized function value not a sensible number')
    end
end

save([outfolder '\maxlike'], 'xx', 'xxnew', 'par');