function [q,piss,Rk,rk,R,pstar,wstar,wplus,kbar,L,lambdaz,m,mb,c,yz,g,inv,Fp,Kp,Fw,Kw,uzc,s,phi,wtilde] = ...
    nobanknoentrss(pibar,parameters)

%this computes the steady state for the version of the CMR model without
%entrepreneurs and without banks. 

%pibar - the inflation updating done by firms that cannot optimize prices.
  
pref = parameters(2);

if pref ~= 1
    error('fatal (nobanknoentrss) program won''t work with this specification of preferences')
end

Hdoupr=parameters(9);

if abs(Hdoupr) > .1e-10
     warning('fatal (nobanknoentrss) this program assumes Hdoupr = 0')
end

entr      = parameters(1);
pref      = parameters(2);
lambdaw   = parameters(3);
sigmaL    = parameters(4);
theta     = parameters(5);
v         = parameters(6);
beta      = parameters(7);
xiw       = parameters(8);
Hdoupr    = parameters(9);
sigmaq    = parameters(10);
b         = parameters(11);
psiL      = parameters(12);
m         = parameters(13);
chii      = parameters(14);
duration  = parameters(15);
zetac     = parameters(16);
iotaw1    = parameters(17);
iotaw2    = parameters(18);
iotamu    = parameters(19);
Fomegabar = parameters(20);
sigma     = parameters(21);
mu        = parameters(22);
gamma     = parameters(23);
we        = parameters(24);
bigtheta  = parameters(25);
sigmaa    = parameters(26);
Sdoupr    = parameters(27);
etai      = parameters(28);
muup      = parameters(29);
zeta      = parameters(30);
muzstar   = parameters(31);
upsil     = parameters(32);
lambdaf   = parameters(33);
alpha     = parameters(34);
psik      = parameters(35);
psil      = parameters(36);
delta     = parameters(37);
epsil     = parameters(38);
xip       = parameters(39);
iota1     = parameters(40);
iota2     = parameters(41);
ksi       = parameters(42);
xb        = parameters(43);
chorse    = parameters(44);
rhobank   = parameters(45);
vl        = parameters(46);
vk        = parameters(47);
etag      = parameters(48);
tauk      = parameters(49);
taul      = parameters(50);
tauc      = parameters(51);
taud      = parameters(52);
tauT      = parameters(53);
tau       = parameters(54);
x         = parameters(55);
do_qavrg  = parameters(90);

if abs(taud) > 0
    error('fatal (nobanknoentrss) taud not zero, program not ready for this')
end


q=1/muup; %eqqq4
piss=(1+x)/muzstar; %eqqq22
Rk=piss*muzstar/beta-1; %eqqq24
rk=(Rk-tauk*delta+1)*upsil*q/piss - (1-delta)*q;
rk=rk/(1-tauk);
R=((piss*muzstar/beta) - 1);
pitild=piss^(iota1+iota2)*(pibar^(1-(iota1+iota2)));

aa=  ( 1 - xip * ((pitild/piss)^(1/(1-lambdaf))) )/( 1 - xip );

bb = 1 - xip*((pitild/piss)^(lambdaf/(1-lambdaf)));

pstar=( (1-xip)*(aa^lambdaf) / bb )^((1-lambdaf)/lambdaf);

piw=muzstar*piss;
pitildw= (piss^(iotaw1+iotaw2)) * (pibar^(1-(iotaw1+iotaw2))) ;

bb=  ( 1 - xiw * ((pitildw*muzstar/piw)^(1/(1-lambdaw))) )/( 1 - xiw );

wstar=( (1-xiw)*(bb^lambdaw) / ( 1 - xiw * ( (pitildw*muzstar/piw)^(lambdaw/(1-lambdaw)) ) ) )^((1-lambdaw)/lambdaw);

wplus=( (1-xiw)*(bb^(lambdaw*(1+sigmaL))) ...
    / ( 1 - xiw * ( (pitildw*muzstar/piw)^(lambdaw*(1+sigmaL)/(1-lambdaw)) ) ) )^((1-lambdaw)/(lambdaw*(1+sigmaL)));

a1 = 1 - ((pitild/piss)^(lambdaf/(1-lambdaf)))*beta*xip;
a2 = 1 - ((pitild/piss)^(1/(1-lambdaf)))*beta*xip;
a3 = 1 - ((pitild/piss)^(1/(1-lambdaf)))*xip;

s = (1/lambdaf) * (a1/a2) * ((a3/(1-xip))^(1-lambdaf));

wtilde=(1/(1+psil*R))*((alpha^alpha)*((1-alpha)^(1-alpha))*s*epsil/( (rk*(1+psik*R))^alpha) )^(1/(1-alpha));

Lk= ((rk*(1+psik*R)/(s*alpha*epsil))^(1/(1-alpha))) / (upsil*muzstar*(wstar^(lambdaw/(lambdaw-1))));

A = (1-etag) * s * epsil * ((upsil*muzstar)^(-alpha)) * ( ((wstar^(lambdaw/(lambdaw-1))) * Lk)^(1-alpha) ) ...
    - (1-(1-delta)/(muzstar*upsil))/muup;

if entr == -1
    
    kbar=8;
    if abs(zetac-1) > .1e-10
        error('fatal (nobanknoentrss) steady state calculation assumes zetac = 1, correcting this is easy')
    end
    [ff,L,lambdaz,m,mb,c,yz,g] = findk(kbar,pitildw,piss,sigmaL,lambdaw,beta,xiw,taul,wtilde,Lk,psil,psik, ...
        zeta,zetac,wstar,rk,upsil,muzstar,R,taud,v,tauc,sigmaq,epsil,etag,b,psiL,A,s,alpha);

    if isnan(ff) | L < 0 | lambdaz < 0 | m < 0 | m > 1 | mb < 0 | c < 0 | yz < 0 | g < 0
        error('fatal (nobanknoentrss) bad initial guess for kbar provided')
    end

    options = optimset('display','off','TolFun',.1e-10,'Tolx',.1e-10);

    [xx,fval,exitflag] = fzero('findk',kbar,options,pitildw,piss,sigmaL,lambdaw,beta,xiw,taul,wtilde,Lk,psil,psik, ...
        zeta,zetac,wstar,rk,upsil,muzstar,R,taud,v,tauc,sigmaq,epsil,etag,b,psiL,A,s,alpha);

    if isnan(fval) == 1 | abs(fval) > .1e-8 | xx < 0 | abs(imag(xx)) > .1e-10 | exitflag < 0
        error('fatal (nobanknoentrss) failed to find a steady state')
    end

    kbar=xx;

    [ff,L,lambdaz,m,mb,c,yz,g] = findk(kbar,pitildw,piss,sigmaL,lambdaw,beta,xiw,taul,wtilde,Lk,psil,psik, ...
        zeta,zetac,wstar,rk,upsil,muzstar,R,taud,v,tauc,sigmaq,epsil,etag,b,psiL,A,s,alpha);

elseif entr == -2

    l=wstar^(lambdaw/(lambdaw-1))*Lk;
    bb1=((1-xiw*(pitildw/piss)^(1/(1-lambdaw)))/(1-xiw))^(1-lambdaw*(1+sigmaL));
    bb2=(1-beta*xiw*(pitildw/piss)^(lambdaw*(1+sigmaL)/(1-lambdaw)))/(1-xiw*beta*(pitildw/piss)^(1/(1-lambdaw)));
    D=((muzstar-b*beta)/(A*(muzstar-b)))*bb1*bb2*(1-taul)*wtilde/((1+tauc)*lambdaw*psiL*zeta*zetac*(l^sigmaL));
    kbar=D^(1/(1+sigmaL));
    L=kbar*Lk;
    c=A*kbar;
    ucz=(muzstar-b*beta)*zetac/(c*(muzstar-b));
    lambdaz=ucz/(zetac*(1+tauc));
    yz=s*epsil*((1/(upsil*muzstar))^alpha)*(l^(1-alpha))*kbar;
    g=etag*yz;
    m=1;
    mb=0;

end

inv=kbar-(1-delta)*kbar/(muzstar*upsil);
Fp=lambdaz*yz/(1-(pitild/piss)^(1/(1-lambdaf))*beta*xip);
Kp=lambdaz*yz*lambdaf*s/(1 - (pitild/piss)^(lambdaf/(1-lambdaf))*beta*xip);
Fw=zetac*wstar^(lambdaw/(lambdaw-1))*L*(1-taul)*lambdaz/lambdaw;
Fw=Fw/(1-beta*xiw*(muzstar*pitildw/piw)^(lambdaw/(1-lambdaw))*pitildw/piss);
Kw=(wstar^(lambdaw/(lambdaw-1))*L)^(1+sigmaL)*zeta*zetac;
Kw=Kw/(1-beta*xiw*(pitildw*muzstar/piw)^(lambdaw*(1+sigmaL)/(1-lambdaw)));
uzc=(1/c)*(muzstar-b*beta)*zetac/(muzstar-b);

aa1 = (1-beta*xip*((pitild/piss)^(lambdaf/(1-lambdaf))))/(1-beta*xip*((pitild/piss)^(1/(1-lambdaf))));
aa2 = ( (1-xip*((pitild/piss)^(1/(1-lambdaf))))/(1-xip) )^(1-lambdaf);
phi = (lambdaf/(aa1*aa2) - pstar^(lambdaf/(1-lambdaf)))*yz;


%now, check the steady state
%as discussed in the manuscript, there are 21 equations that are set to
%zero in the steady state. One of them, eq5, is used to determine the
%derivative of the utilization cost function, and is not checked below.
%eq2:
err(1)=s-((1/(1-alpha))^(1-alpha))*((1/alpha)^alpha)*((rk*(1+psik*R))^alpha)*((wtilde*(1+psil*R))^(1-alpha))/epsil;
%eq3:
err(2) = s - rk*(1+psik*R)/(alpha*epsil*( ( upsil*muzstar*(wstar^(lambdaw/(lambdaw-1))) * L/kbar )^(1-alpha) ) );
%eq4:
err(3) = q - 1/muup;
%eq6:
err(4) = Rk - (((1-tauk)*rk + (1-delta)*q)*piss/(upsil*q)) - tauk*delta + 1;
%eq14:
err(5) = uzc - (1/c)*(muzstar-b*beta)*zetac/(muzstar-b);
if entr == -1;%equation 16 is dropped with entr = -2
    %eq16
    err(6) = zetac * v * (((1+tauc)*c)^(1-sigmaq)) * ((piss*muzstar/(m*mb))^(2-sigmaq)) - lambdaz*R;
end
%eq17
err(7)=(beta/(piss*muzstar))*(1+R) - 1;
if entr == -1
%eq18
    err(8)=uzc-zetac * v * (c^(-sigmaq)) * (((1+tauc)*piss*muzstar/(m*mb))^(1-sigmaq)) - (1+tauc)*zetac*lambdaz;
elseif entr == -2
    err(8)=uzc - (1+tauc)*zetac*lambdaz;
end
%eq21
err(9)=kbar-(1-delta)*kbar/(muzstar*upsil)-inv;
%eq22
err(10)=piss-(1+x)/muzstar;
%eq24
err(11)=Rk-piss*muzstar/beta+1;
if entr == -1;%when entr = -2, we drop equation 25
%eq25
    err(12)=psil*wtilde*L*(wstar^(lambdaw/(lambdaw-1))) + psik*rk*kbar/(upsil*muzstar) - mb*(1-m)/(piss*muzstar);
end
%eq31
err(13)=pstar-((1-xip)*( (1 - xip * ((pitild/piss)^(1/(1-lambdaf))))/(1-xip))^lambdaf + ...
    xip*(pitild*pstar/piss)^(lambdaf/(1-lambdaf)))^((1-lambdaf)/lambdaf);
%eq32
www= (1-xiw*(( (pitildw/piw)*muzstar )^(1/(1-lambdaw))))/(1-xiw);
err(14)=wstar-( (1-xiw)*www^lambdaw + xiw*( (pitildw/piw) * muzstar*wstar)^(lambdaw/(1-lambdaw)) )^((1-lambdaw)/lambdaw);
%eq33
err(15)=lambdaz*yz+(pitild/piss)^(1/(1-lambdaf))*beta*xip*Fp-Fp;
%eq34
err(16)=lambdaf*lambdaz*yz*s+beta*xip*((pitild/piss)^(lambdaf/(1-lambdaf)))*Kp-Kp;
%eq20
err(17)=g+c+inv/muup-yz;
%eq35
err(18)=zetac*wstar^(lambdaw/(lambdaw-1))*L*(1-taul)*lambdaz/lambdaw + beta*xiw*muzstar^(lambdaw/(1-lambdaw)) ...
    *piw^(lambdaw/(lambdaw-1))*pitildw^(1/(1-lambdaw))*Fw/piss - Fw;
%eq36
err(19)=(wstar^(lambdaw/(lambdaw-1))*L)^(1+sigmaL)*zetac*zeta ...
    + beta*xiw*(pitildw*muzstar/piw)^(lambdaw*(1+sigmaL)/(1-lambdaw))*Kw-Kw;
%eq37
wx=(1-xiw*(pitildw*muzstar/piw)^(1/(1-lambdaw)))/(1-xiw);
err(20)=wplus-((1-xiw)*wx^(lambdaw*(1+sigmaL)) + xiw*(pitildw*muzstar*wplus/piw)^(lambdaw*(1+sigmaL)/(1-lambdaw)))^((1-lambdaw)/(lambdaw*(1+sigmaL)));
%check on phi
err(21)=yz-s*(yz*(pstar^(lambdaf/(1-lambdaf)))+phi);

 
if max(abs(err)) > .1e-8
    error('fatal (nobanknoentrss) failed to compute the steady state for the no banks-no entrepreneur version of the model')
end

pi=piss;
i=inv;
u=1;
w=wtilde;
k=kbar;
Re=R;
h=L;
xi=0;
xp=0;

%construct average q
qavrg = muzstar*( (vk*(kbar/(muzstar*upsil))^alpha *l^(1-alpha) -phi) - w*l -inv) / ( (1-delta)*kbar*(1-beta)/(upsil*muup));

loadupnonlinnew

ppnonlin=[zp1'; z0'; zm1'; psip1'; psip0'];

Re=0;
Taylor=2;
country=1;
forward=1;
parameters(64) = phi;
[ff] = nonlinnew(ppnonlin,parameters,piss,rk,country,Taylor,forward,Re,c,i,g,R);


%these are the elements in ff that we're interested in
%they correspond to the equation numbers in the *.tex file, except that
%32-38 corresponds to (eq31)-(eq37) in the *.tex file.
if entr == -1
    tt=[2 3 4 5 9 14 16 17 18 20 21 22 24 25 32 33 34 35 36 37 38];
elseif entr == -2;%we dropped equations 16, 18, 22, 25 (we dropped x(t), lambdaz(t), m(t), mb(t))
    tt=[2 3 4 5 9 14 17 20 21 24 32 33 34 35 36 37 38];
end

%another check on the accuracy of the steady state calculations:

if max(abs(ff(tt))) > .1e-8
    error('fatal (nobanknoentrss) failed to compute steady state')
end

