function table_residuals(outfolder,vbname,MeanShocks,CorrAuto,CorrShocks,name,entr,cdir)

nameshock= strrep(vbname(1,:),'\','\\');
for kk=2:size(vbname,1)
    nameshock = char(nameshock,strrep(vbname(kk,:),'\','\\'));
end

CorrAuto = round(100*CorrAuto')/100; %we round all entries to nearest integer. As numbers are in percent, this is not a problem
CorrShocks = ceil(100*CorrShocks)/100;

ncol = size(nameshock,1)+2; %the last two are used for string with type of analysis and shock names
lengthxx = size(nameshock,1);

fid=fopen([outfolder '\write_temp.m'],'w');

fprintf(fid,['fid = fopen(''' [strrep(cdir,'\','\\') '\\' outfolder(3:end) '\\' name] ''',''w''); \n']);

fprintf(fid,'fprintf(fid,'' \\\\documentclass{article} \\n''); \n');
fprintf(fid,'fprintf(fid,'' %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\usepackage{amsfonts} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\usepackage{amsmath} \\n''); \n');

fprintf(fid,'fprintf(fid,'' \\\\setcounter{MaxMatrixCols}{10} \\n''); \n');
fprintf(fid,'fprintf(fid,'' %%%%TCIDATA{OutputFilter=LATEX.DLL} \\n''); \n');
fprintf(fid,'fprintf(fid,'' %%%%TCIDATA{Version=4.10.0.2345} \\n''); \n');
fprintf(fid,'fprintf(fid,'' %%%%TCIDATA{Created=Thursday, October 31, 2002 05:55:21} \\n''); \n');
fprintf(fid,'fprintf(fid,'' %%%%TCIDATA{LastRevised=Thursday, October 31, 2002 06:08:51} \\n''); \n');
fprintf(fid,'fprintf(fid,'' %%%%TCIDATA{<META NAME="GraphicsSave" CONTENT="32">} \\n''); \n');
fprintf(fid,'fprintf(fid,'' %%%%TCIDATA{<META NAME="DocumentShell" CONTENT="Standard LaTeX\\\\Standard LaTeX Article">} \\n''); \n');
fprintf(fid,'fprintf(fid,'' %%%%TCIDATA{CSTFile=40 LaTeX article.cst} \\n''); \n');

fprintf(fid,'fprintf(fid,'' \\\\newtheorem{theorem}{Theorem} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{acknowledgement}[theorem]{Acknowledgement} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{algorithm}[theorem]{Algorithm} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{axiom}[theorem]{Axiom} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{case}[theorem]{Case} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{claim}[theorem]{Claim} \\n''); \n' );
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{conclusion}[theorem]{Conclusion} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{condition}[theorem]{Condition} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{conjecture}[theorem]{Conjecture} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{corollary}[theorem]{Corollary} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{criterion}[theorem]{Criterion} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{definition}[theorem]{Definition} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{example}[theorem]{Example} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{exercise}[theorem]{Exercise} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{lemma}[theorem]{Lemma} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{notation}[theorem]{Notation} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{problem}[theorem]{Problem} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{proposition}[theorem]{Proposition} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{remark}[theorem]{Remark} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{solution}[theorem]{Solution} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{summary}[theorem]{Summary} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newenvironment{proof}[1][Proof]{\\\\noindent\\\\textbf{#1.} }{\\\\ \\\\rule{0.5em}{0.5em}} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\input{tcilatex} \\n''); \n');

fprintf(fid,'fprintf(fid,'' \\\\begin{document} \\n''); \n');

fprintf(fid,'fprintf(fid,'' \\\\begin{equation*} \\n''); \n');

nn = '|l|l||';
for ii=1:ncol-2
    nn = [nn 'c|'];
end
fprintf(fid,['fprintf(fid,'' \\\\begin{tabular}{' nn '} \\\\hline \\n ''); \n']);

fprintf(fid,['fprintf(fid,'' \\\\multicolumn{' num2str(ncol) '}{|c|}{Table: Properties of the Economic Shocks'''' Innovations in entr=' num2str(entr) ' Model} \\\\\\\\ [1.5ex] \\\\hline \\n ''); \n']);

fprintf(fid,' keyboard  \n');

nameshock_ = ['''$' deblank(nameshock(1,:)) '$'''];
ssf = '\\\\multicolumn{1}{|c|}{%%s}';
for ii=2:ncol-2
    nameshock_ = [nameshock_ ',''$' deblank(nameshock(ii,:)) '$'''];
    ssf = [ssf '& \\\\multicolumn{1}{|c|}{%%s}'];
end
ssf = ['\\\\multicolumn{1}{|l}{} & \\\\multicolumn{1}{l||}{} & ' ssf];

fprintf(fid,['fprintf(fid,'' '  ssf ' \\\\\\\\ [1.5ex] \\\\hline \\\\hline \\n'',' nameshock_ '); \n']);


rowii = num2str(MeanShocks(1),2);
    for jj=2:ncol-2
        rowii = [rowii ' & ' num2str(MeanShocks(jj),2)];
    end
rowii = ['\\\\multicolumn{1}{|l}{Mean} & \\\\multicolumn{1}{l||}{} & ' rowii];
fprintf(fid,['fprintf(fid,'' ' rowii   ' \\\\\\\\  \\\\hline \\n''); \n']);
    

rowii = num2str(CorrAuto(1),2);
    for jj=2:ncol-2
        rowii = [rowii ' & ' num2str(CorrAuto(jj),2)];
    end
rowii = ['\\\\multicolumn{1}{|l}{Auto-Correlation} & \\\\multicolumn{1}{l||}{} & ' rowii];
fprintf(fid,['fprintf(fid,'' ' rowii   ' \\\\\\\\  \\\\hline \\n''); \n']);

fprintf(fid,['fprintf(fid,'' \\\\multicolumn{1}{|l}{Cross-Correlation} &  \\\\multicolumn{1}{l||}{}&  \\\\multicolumn{' num2str(ncol-2) '}{|l|}{}   \\\\\\\\  \\n''); \n']);

for ii=1:lengthxx
    if ii==1
        rowii = num2str(CorrShocks(ii,1),2);
    else
        rowii = ' ';
    end
    for jj=2:ncol-2
        if jj>=ii
            rowii = [rowii ' & ' num2str(CorrShocks(ii,jj),2)];
        else
            rowii = [rowii ' & '];
        end
    end
    
    rowii = ['\\\\multicolumn{1}{|l|}{} & \\\\multicolumn{1}{|l||}{%%s} & ' rowii];
    if ii<lengthxx
            fprintf(fid,['fprintf(fid,'' ' rowii   ' \\\\\\\\  \\\\cline{2-' num2str(ncol) '} \\n'',' '''$' deblank(nameshock(ii,:)) '$''' '); \n']);
    elseif ii==lengthxx
            fprintf(fid,['fprintf(fid,'' ' rowii   ' \\\\\\\\  \\\\hline \\n'',' '''$' deblank(nameshock(ii,:)) '$''' '); \n']);
    end
end


fprintf(fid,'fprintf(fid,'' \\\\end{tabular}%%%% \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\end{equation*}%%%% \\n''); \n');

fprintf(fid,['fprintf(fid,'' {\\\\small Note: }{\\\\small Figures refer to the smoothed innovations.}\\n''); \n']);

fprintf(fid,'fprintf(fid,'' \\\\end{document} \\n''); \n');
fprintf(fid,'fclose(fid);');

fclose(fid);

addpath([cdir outfolder(2:end)])
write_temp
rmpath([cdir outfolder(2:end)])
